<?php
$vercode=''; //此处取值请自行修改
if(isset($_POST['vercode'])){
if ($_POST['vercode']!=$vercode){
 echo("[err]invalid vercode[/err]");
 exit();
}
}

define('SCR','post');
//require_once ('global.php');
//file_exists('install.php') && header('Location: ./install.php');
error_reporting(E_ERROR | E_PARSE);
set_magic_quotes_runtime(0);
function_exists('date_default_timezone_set') && date_default_timezone_set('Etc/GMT+0');

define('R_P',getdirname(__FILE__));
define('D_P',R_P);
define('AREA_PATH',R_P.'html/channel/');
define('PORTAL_PATH',R_P.'html/portal/');
define('A_P', R_P.'apps/');
define('P_W','global');
defined('SCR') || define('SCR','other');

$P_S_T  = pwMicrotime();
require_once(R_P.'require/common.php');
S::filter();
require_once(D_P.'data/bbscache/config.php');

$db_debug && error_reporting(E_ALL ^ E_NOTICE ^ E_DEPRECATED);
//zzcity add
//$timestamp = time();
$zzhours = empty($_POST['zzhours']) ? '1' : intval($_POST['zzhours']); 
$timestamp =time()-$zzhours*60*60;  //主题时间提前zzhour小时
$zzmins = empty($_POST['zzmins']) ? '5' : intval($_POST['zzmins']);  //回帖时间随机分钟
$timestamp = $timestamp+((int)$_POST['replyno'])*$zzmins*60+(rand(1,$zzmins)*60);  //zzcity add
//zzdicy add end
$db_cvtime!=0 && $timestamp += $db_cvtime*60;
$wind_in = $SCR = SCR;

$onlineip = pwGetIp();
if ($db_forcecharset && !defined('W_P') && !defined('AJAX')) {
 @header("Content-Type:text/html; charset=$db_charset");
}
if ($db_loadavg && !defined('W_P') && pwLoadAvg($db_loadavg)) {
 $db_cc = 2;
}
if ($db_cc && !defined('COL')) {
 pwDefendCc($db_cc);
}

if ($db_dir && $db_ext) {
 $_NGET = array();
 $self_array = explode('-',substr($pwServer['QUERY_STRING'],0,strpos($pwServer['QUERY_STRING'],$db_ext)));
 for ($i=0, $s_count=count($self_array); $i<$s_count-1;$i++) {
  $_key = $self_array[$i];
  $_value = rawurldecode($self_array[++$i]);
  $_NGET[$_key] = addslashes($_value);
 }
 !empty($_NGET) && $_GET = $_NGET;
 unset($_NGET);
}

foreach ($_POST as $_key => $_value) {
 if (!in_array($_key,array('atc_content','atc_title','prosign','pwuser','pwpwd'))) {
  CheckVar($_POST[$_key]);
 }
}
foreach ($_GET as $_key => $_value) {
 CheckVar($_GET[$_key]);
}

list($wind_version,$wind_repair,$wind_from) = explode(',',WIND_VERSION);
$db_olsize    = 96;

if (false !== ($dirstrpos = strpos($pwServer['PHP_SELF'],$db_dir))) {
 $tmp = substr($pwServer['PHP_SELF'],0,$dirstrpos);
 $pwServer['PHP_SELF'] = "$tmp.php";
 unset($dirstrpos);
} else {
 $tmp = $pwServer['PHP_SELF'];
}
$REQUEST_URI = $pwServer['PHP_SELF'].($pwServer['QUERY_STRING'] ? '?'.$pwServer['QUERY_STRING'] : '');

$_mainUrl = $index_url = $db_bbsurl;
$R_url = $db_bbsurl = Char_cv("http://".$pwServer['HTTP_HOST'].substr($tmp,0,strrpos($tmp,'/')));
defined('SIMPLE') && SIMPLE && $db_bbsurl = substr($db_bbsurl,0,-7);
$defaultMode = empty($db_mode) ? 'bbs' : $db_mode;
$db_mode = 'bbs';

if ($cookie_lastvisit = GetCookie('lastvisit')) {
 list($c_oltime,$lastvisit,$lastpath) = explode("\t",$cookie_lastvisit);
 ($onbbstime=$timestamp-$lastvisit)<$db_onlinetime && $c_oltime+=$onbbstime;
 unset($cookie_lastvisit);
} else {
 $lastvisit = $lastpath = '';
 $c_oltime = $onbbstime = 0;
 Cookie('lastvisit',$c_oltime."\t".$timestamp."\t".$REQUEST_URI);
}

InitGP(array('fid','tid'),'GP',2);
//zzcity add
InitGP(array('fid'));

$zzfids=explode(',',$fid);
if (count($zzfids)>0){
 $fid=(int)$zzfids[rand(0,count($zzfids)-1)];
}else
{
 echo('[err]fid is error[/err]');
 exit;
}

//zzcity add end

$db = $ftp = $credit = null;

require_once(D_P.'data/sql_config.php');
!is_array($manager) && $manager = array();
$newmanager = array();
foreach ($manager as $key => $value) {
 if (!empty($value) && !is_array($value)) {
  $newmanager[$key] = $value;
 }
}
$manager = $newmanager;
if ($database == 'mysqli' && Pwloaddl('mysqli') === false) {
 $database = 'mysql';
}
ObStart();//noizy

if ($db_http != 'N') {
 $imgpath = $db_http;
 if (D_P != R_P) {
  $R_url = substr($db_http,-1)=='/' ?  substr($db_http,0,-1) : $db_http;
  $R_url = substr($R_url,0,strrpos($R_url,'/'));
 }
} else {
 $imgpath = $db_picpath;
}
list($attachpath,$imgdir,$attachdir,$pw_posts,$pw_tmsgs,$runfc) = array($db_attachurl != 'N' ? $db_attachurl : $db_attachname, R_P.$db_picpath, R_P.$db_attachname, 'pw_posts', 'pw_tmsgs', 'N');
list($winduid,$windpwd,$safecv) = explode("\t",addslashes(StrCode(GetCookie('winduser'),'DECODE')));

$loginhash = GetVerify($onlineip,$db_pptkey);
if ($db_pptifopen && $db_ppttype == 'client') {
 if (strpos($db_pptloginurl,'?') === false) {
  $db_pptloginurl .= '?';
 } elseif (substr($db_pptloginurl,-1) != '&') {
  $db_pptloginurl .= '&';
 }
 if (strpos($db_pptregurl,'?') === false) {
  $db_pptregurl .= '?';
 } elseif (substr($db_pptregurl,-1) != '&') {
  $db_pptregurl .= '&';
 }
 $urlencode = rawurlencode($db_bbsurl);
 $loginurl = "$db_pptserverurl/{$db_pptloginurl}forward=$urlencode";
 $loginouturl= "$db_pptserverurl/$db_pptloginouturl&forward=$urlencode&verify=$loginhash";
 $regurl  = "$db_pptserverurl/{$db_pptregurl}forward=$urlencode";
} else {
 $loginurl = 'login.php';
 $loginouturl= "login.php?action=quit&verify=$loginhash";
 $regurl  = $db_registerfile;
}

$ol_offset = (int)GetCookie('ol_offset');
$skinco    = GetCookie('skinco');

if ($db_refreshtime && str_replace("=",'',$REQUEST_URI) == $lastpath && $onbbstime < $db_refreshtime) {
 !GetCookie('winduser') && $groupid = 'guest';
 $skin = $skinco ? $skinco : $db_defaultstyle;
 Showmsg('refresh_limit');
}
if (!$db_bbsifopen && !defined('CK')) {
 require_once(R_P.'require/bbsclose.php');
}

$H_url =& $db_wwwurl;
$B_url =& $db_bbsurl;
$_time  = array('hours'=>get_date($timestamp,'G'),'day'=>get_date($timestamp,'j'),'week'=>get_date($timestamp,'w'));
$tdtime  = PwStrtoTime(get_date($timestamp,'Y-m-d'));
$montime = PwStrtoTime(get_date($timestamp,'Y-m').'-1');

if (!defined('CK') && ($_COOKIE || $timestamp%3 == 0)) {
 switch (SCR) {
  case 'thread': $lastpos = "F$fid";break;
  case 'read': $lastpos = "T$tid";break;
  case 'cate': $lastpos = "C$fid";break;
  case 'index': $lastpos = 'index';break;
  case 'mode': $lastpos = $db_mode;break;
  default: $lastpos = 'other';
 }
 if ($timestamp-$lastvisit>$db_onlinetime || $lastpos != GetCookie('lastpos')) {
  $runfc = 'Y';
  Cookie('lastpos',$lastpos);
 }
}
//zzcity add 用户登录
PwNewDB();
 $etuser = $db->get_one("SELECT uid,password FROM pw_members  WHERE username=".pwEscape($_POST['pwuser']));
 $winduid=$etuser['uid'];
 $windpwd=$etuser['password'];

//zzcity add end


if (is_numeric($winduid) && strlen($windpwd)>=16) {
 $winddb   = User_info();
 list($winduid,$groupid,$userrvrc,$windid,$_datefm,$_timedf,$credit_pop) = array($winddb['uid'],$winddb['groupid'],floor($winddb['rvrc']/10),$winddb['username'],$winddb['datefm'],$winddb['timedf'],$winddb['creditpop']);

 if ($credit_pop && $db_ifcredit) {//Credit Changes Tips
  $credit_pop = str_replace(array('&lt;','"','&gt;'),array('<','"','>'),$credit_pop);
  $creditdb = explode('|',$credit_pop);
  $credit_pop = Char_cv(GetCreditLang('creditpop',$creditdb['0']));

  unset($creditdb['0']);
  foreach ($creditdb as $val) {
   list($credit_1,$credit_2) = explode(':',$val);
   $credit_pop .= '<span class="st2">'.pwCreditNames($credit_1).'&nbsp;<span class="f24">'.$credit_2.'</span></span>';
  }
  $userService = L::loadClass('UserService', 'user'); /* @var $userService PW_UserService */
  $userService->update($winduid, array(), array('creditpop' => ''));
 }

 list($winddb['style'],$ifcustomstyle) = explode('|',$winddb['style']);
 $skin   = $winddb['style'] ? $winddb['style'] : $db_defaultstyle;
 list($winddb['onlineip']) = explode('|',$winddb['onlineip']);
 $groupid == '-1' && $groupid = $winddb['memberid'];
 $winddb['lastpost'] < $tdtime && $winddb['todaypost'] = 0;
 $curvalue = $db_signcurtype == 'rvrc' ? $userrvrc : $winddb[$db_signcurtype];
 if (getstatus($winddb['userstatus'], PW_USERSTATUS_SHOWSIGN) && (!$winddb['starttime'] && $db_signmoney && strpos($db_signgroup,",$groupid,") !== false && $curvalue > $db_signmoney || $winddb['starttime'] && $winddb['starttime'] != $tdtime)) {
  require_once(R_P.'require/Signfunc.php');
  Signfunc($winddb['starttime'],$curvalue);
 }
 unset($curvalue);
} else {
 $skin  = $db_defaultstyle;
 $groupid = 'guest';
 $winddb  = $windid = $winduid = $_datefm = $_timedf = '';
}
$verifyhash = GetVerify($winduid);

if ($db_bbsifopen==2 && SCR!='login' && !defined('CK')) {
 require_once(R_P.'require/bbsclose.php');
}

if ($db_ifsafecv && !$safecv && !defined('PRO') && strpos($db_safegroup,",$groupid,") !== false ) {
 Showmsg('safecv_prompt');
}

include_once(D_P.'data/bbscache/inv_config.php');
if ($inv_linkopen && $inv_linktype=='1' && !$windid && (is_numeric($_GET['uid']) || ($_GET['a'] && strlen($_GET['a'])<16)) && strpos($pwServer['HTTP_REFERER'],$pwServer['HTTP_HOST'])===false) {
 InitGP(array('uid','a'));
 Cookie('userads',"$uid\t$a\t".md5($pwServer['HTTP_REFERER']));
} elseif ($inv_linkopen && $inv_linktype=='0' && is_numeric($_GET['u'])) {
 InitGP(array('uid'));
 if ((int)$uid>0) {
  require_once(R_P.'require/userads.php');
 }
}
unset($u,$a,$cookie_userads);

($_POST['skinco']) ? $skinco = $_POST['skinco'] : (($_GET['skinco']) ? $skinco = $_GET['skinco'] : '');
if ($skinco && strpos($skinco,'..')===false && file_exists(D_P."data/style/$skinco.php") ) {
 $skin = $skinco;
 Cookie('skinco',$skin);
}

if ($db_columns && !defined('W_P') && !defined('SIMPLE') && !defined('COL') && !defined('CK')) {
 $j_columns = GetCookie('columns');
 if (!$j_columns) {
  $db_columns==2 && $j_columns = 2;
  Cookie('columns',$j_columns);
 }
 if ($j_columns==2 && (strpos($pwServer['HTTP_REFERER'],$db_bbsurl)===false || strpos($pwServer['HTTP_REFERER'],$db_adminfile)!==false)) {
  strpos($REQUEST_URI,'index.php')===false ? Cookie('columns','1') : ObHeader('columns.php?action=columns');
 }
 unset($j_columns);
}
Ipban();

Cookie('lastvisit',$c_oltime."\t".$timestamp."\t".$REQUEST_URI);

if ($groupid == 'guest' && $db_guestdir && GetGcache()) {
 require_once(R_P.'require/guestfunc.php');
 getguestcache();
}
PwNewDB();
unset($db_whybbsclose,$db_whycmsclose,$db_ipban,$db_diy,$dbhost,$dbuser,$dbpw,$dbname,$pconnect,$manager_pwd,$newmanager);
if ($groupid == 'guest') {
 require_once(D_P.'data/groupdb/group_2.php');
} elseif (file_exists(D_P."data/groupdb/group_$groupid.php")) {
 require_once Pcv(D_P."data/groupdb/group_$groupid.php");
} else {
 require_once(D_P.'data/groupdb/group_1.php');
}
visitRightByGroup();
if ($_G['pwdlimitime'] && !defined('PRO') && !CkInArray($windid,$manager) && $timestamp-86400*$_G['pwdlimitime']>$winddb['pwdctime'] ) {
 Showmsg('pwdchange_prompt');
}

//响应

/**
 * 跳转
 *
 * @global string $db_ifjump
 * @param string $URL 跳转url
 * @param string $content 跳转提示信息
 * @param int $statime 几秒后跳转
 * @param bool $forcejump
 */
function refreshto($URL, $content, $statime = 1, $forcejump = false) {
 if (defined('AJAX')) Showmsg($content);
 global $db_ifjump,$db_htmifopen;

 if (!$forcejump && !($db_ifjump && $statime > 0)) {
  ObHeader($URL);
 } else {
  if ($db_htmifopen && strtolower(substr($URL,0,4))!=='http') {
   $URL = urlRewrite($URL);
  }
  ob_end_clean();
  global $expires, $db_charset, $tplpath, $fid, $imgpath, $db_obstart, $db_bbsname, $B_url, $forumname, $tpctitle, $db_bbsurl;
  $index_name = & $db_bbsname;
  $index_url = & $B_url;
  ObStart(); //noizy
  extract(L::style());

  $content = getLangInfo('refreshto', $content);
  require PrintEot('refreshto');
  $output = str_replace(array('<!--<!---->', '<!---->', "\r\n\r\n"), '', ob_get_contents());
  echo ObContents($output);
  exit();
 }
}

/**
 * 302跳转
 *
 * @param string $url
 */

/*
function ObHeader($url) {
 ob_end_clean();
 header("Location: $url");
 exit();
}*/
function ObHeader($URL){
 global $db_obstart,$db_bbsurl,$db_htmifopen;
 if ($db_htmifopen && strtolower(substr($URL,0,4))!=='http') {
  $URL = urlRewrite($URL);
 }
 ob_end_clean();
 if (!$db_obstart) {
  ObStart();
  echo "<meta http-equiv='refresh' content='0;url=$URL'>";
  exit;
 }
 header("Location: $URL");
 exit;
}

/**
 * 显示系统提示信息
 *
 * @param string $msg_info 信息内容
 * @param int $dejump ?
 */
//function Showmsg($msg_info, $dejump = 0) {
// @extract($GLOBALS, EXTR_SKIP);
// global $stylepath, $tablewidth, $mtablewidth, $tplpath, $db;
// define('PWERROR', 1);
// $msg_info = getLangInfo('msg', $msg_info);
// if (defined('AJAX')) {
//  echo $msg_info;
//  ajax_footer();
// }
// $showlogin = false;
// if ($dejump != '1' && $groupid == 'guest' && $REQUEST_URI == str_replace(array('register', 'login'), '', $REQUEST_URI) && (!$db_pptifopen || $db_ppttype != 'client')) {
//  if (strpos($REQUEST_URI, 'post.php') !== false || strpos($REQUEST_URI, 'job.php?action=vote') !== false || strpos($REQUEST_URI, 'job.php?action=pcjoin') !== false) {
//   $tmpTid = (int) GetGP('tid', 'GP');
//   $tmpTid && $REQUEST_URI = substr($REQUEST_URI, 0, strrpos($REQUEST_URI, '/')) . "/read.php?tid=$tmpTid&toread=1";
//  }
//  $jumpurl = "http://" . $pwServer['HTTP_HOST'] . $REQUEST_URI;
//  list(, $qcheck) = explode("\t", $db_qcheck);
//  $qkey = $qcheck && $db_question ? array_rand($db_question) : '';
//  $showlogin = true;
// }
// extract(L::style());
// list($_Navbar, $_LoginInfo) = pwNavBar();
// ob_end_clean();
// ObStart();
// require_once PrintEot('showmsg');
// exit();
//}
//zzcity add
function Showmsg($msg_info, $dejump = 0) {
 echo $msg_info;
 @extract($GLOBALS, EXTR_SKIP);
 global $stylepath, $tablewidth, $mtablewidth, $tplpath, $db;
 define('PWERROR', 1);
 $msg_info = getLangInfo('msg', $msg_info);
 //ob_end_clean();
 ObStart();
 echo '[err]'.$msg_info.'[/err]';
 exit();
}
//zzcity add end

/**
 * 设置响应头
 *
 * @param int $num 响应状态码
 * @param bool $rtarr 是否返回响应头字符串
 * @return string
 */
function sendHeader($num, $rtarr = null) {
 static $sapi = null;
 if ($sapi === null) {
  $sapi = php_sapi_name();
 }
 $header_a = array('200' => 'OK', '206' => 'Partial Content', '304' => 'Not Modified', '404' => '404 Not Found',
  '416' => 'Requested Range Not Satisfiable');
 if ($header_a[$num]) {
  if ($sapi == 'cgi' || $sapi == 'cgi-fcgi') {
   $headermsg = "Status: $num " . $header_a[$num];
  } else {
   $headermsg = "HTTP/1.1: $num " . $header_a[$num];
  }
  if (empty($rtarr)) {
   header($headermsg);
  } else {
   return $headermsg;
  }
 }
 return '';
}

//全局业务

/**
 * 禁止ip
 *
 * @global string $db_ipban
 */
function Ipban() {
 global $db_ipban;
 if ($db_ipban) {
  global $onlineip, $imgpath, $stylepath;
  $baniparray = explode(',', $db_ipban);
  $ip = explode(".",$onlineip);
  if( in_array($ip[0],$baniparray) || in_array($ip[0].'.'.$ip[1],$baniparray) || in_array($ip[0].'.'.$ip[1].'.'.$ip[2],$baniparray) || in_array($ip[0].'.'.$ip[1].'.'.$ip[2].'.'.$ip[3],$baniparray)) {
   Showmsg('ip_ban');
  }
 }
}

//用户业务

/**
 * 获取用户信息
 *
 * @global DB $db
 * @param int $uid
 * @return array
 */
function getUserByUid($uid) {
 global $db;
 $sqladd = $sqltab = '';
 if (in_array(SCR, array('index', 'read', 'thread', 'post'))) {
  $sqladd = (SCR == 'post') ? ',md.postcheck,sr.visit,sr.post,sr.reply' : ',sr.visit';
  $sqltab = "LEFT JOIN pw_singleright sr ON m.uid=sr.uid";
 }
 $detail = $db->get_one("SELECT m.uid,m.username,m.password,m.safecv,m.email,m.oicq,m.groupid,m.memberid,m.groups,m.icon,m.regdate,m.honor,m.timedf, m.style,m.datefm,m.t_num,m.p_num,m.yz,m.newpm,m.userstatus,m.shortcut,md.lastmsg,md.postnum,md.rvrc,md.money,md.credit,md.currency,md.lastvisit,md.thisvisit,md.onlinetime,md.lastpost,md.todaypost,md.monthpost,md.onlineip,md.uploadtime,md.uploadnum,md.starttime,md.pwdctime,md.monoltime,md.digests,md.f_num,md.creditpop,md.jobnum,md.lastgrab,md.follows,md.fans,md.newfans,md.newreferto,md.newcomment $sqladd FROM pw_members m LEFT JOIN pw_memberdata md ON m.uid=md.uid $sqltab WHERE m.uid=" . pwEscape($uid) . " AND m.groupid<>'0' AND md.uid IS NOT NULL");
 return $detail;
}

/**
 * 获取用户信息
 */
function User_info() {
 global $db, $timestamp, $db_onlinetime, $winduid, $windpwd, $safecv, $db_ifonlinetime, $c_oltime, $onlineip, $db_ipcheck, $tdtime, $montime, $db_ifsafecv, $db_ifpwcache, $uc_server;
 PwNewDB();
 $detail = getUserByUid($winduid);
 if (empty($detail) && $uc_server) {
  require_once (R_P . 'require/ucuseradd.php');
 }
 $loginout = 0;
 if ($db_ipcheck && strpos($detail['onlineip'], $onlineip) === false) {
  $iparray = explode('.', $onlineip);
  strpos($detail['onlineip'], $iparray[0] . '.' . $iparray[1]) === false && $loginout = 1;
 }
// if (!$detail || PwdCode($detail['password']) != $windpwd || ($db_ifsafecv && $safecv != $detail['safecv']) || $loginout || $detail['yz'] > 1) {
//  $GLOBALS['groupid'] = 'guest';
//  require_once (R_P . 'require/checkpass.php');
//  Loginout();
//  if ($detail['yz'] > 1) {
//   $GLOBALS['jihuo_uid'] = $detail['uid'];
//   Showmsg('login_jihuo');
//  }
//  Showmsg('ip_change');
// } else {
  list($detail['shortcut'], $detail['appshortcut']) = explode("\t", $detail['shortcut']);
  unset($detail['password']);
  $detail['honor'] = substrs($detail['honor'], 90);
  $distime = $timestamp - $detail['lastvisit'];
  if ($distime > $db_onlinetime || $distime > 3600) {
   /*--- element update ---start*/
   if ($db_ifpwcache & 1 && SCR != 'post' && SCR != 'thread') {
    L::loadClass('elementupdate', '', false);
    $elementupdate = new ElementUpdate();
    $elementupdate->userSortUpdate($detail);
   }
   /*--- element update ---end*/
   if (!GetCookie('hideid')) {
    $userService = L::loadClass('UserService', 'user'); /* @var $userService PW_UserService */

    $updateMemberData = $updateByIncrementMemberData = array();
    $updateMemberData['lastvisit'] = $timestamp;
    $updateMemberData['thisvisit'] = $timestamp;

    if ($db_ifonlinetime) {
     $c_oltime = intval($c_oltime);
     $c_oltime = $c_oltime <= 0 ? 0 : ($c_oltime > $db_onlinetime * 1.2 ? $db_onlinetime : $c_oltime);
     $updateByIncrementMemberData['onlinetime'] = $c_oltime;
     if ($detail['lastvisit'] > $montime) {
      $updateByIncrementMemberData['monoltime'] = $c_oltime;
     } else {
      $updateMemberData['monoltime'] = $c_oltime;
     }
     if ($c_oltime) {
      require_once (R_P . 'require/functions.php');
      updateDatanalyse($winduid, 'memberOnLine', $c_oltime);
     }
     $c_oltime = 0;
    }
    
    $userService->update($winduid, array(), $updateMemberData);
    $updateByIncrementMemberData && $userService->updateByIncrement($winduid, array(), $updateByIncrementMemberData);
    
    $detail['lastvisit'] = $detail['thisvisit'] = $timestamp;
   }
  }
// }
 return $detail;
}

/**
 * 检查用户是否为版块管理员
 *
 * @param string $forumAdmins 版块管理员
 * @param string $fupAdmins 父版块管理员
 * @param string $username 用户名
 * @return bool
 */
function admincheck($forumAdmins, $fupAdmins, $username) {
 if (!$username) {
  return false;
 }
 if ($forumAdmins && strpos($forumAdmins, ",$username,") !== false) {
  return true;
 }
 if ($fupAdmins && strpos($fupAdmins, ",$username,") !== false) {
  return true;
 }
 return false;
}

/**
 * 检查是否允许?
 *
 * @param string $allowGroups 允许的用户组
 * @param int $groupId 用户用户组
 * @param string $userGroups 用户的用户组
 * @param int|string $fid
 * @param string $allowForums 允许的论坛
 * @return bool
 */
function allowcheck($allowGroups, $groupId, $userGroups, $fid = '', $allowForums = '') {
 if ($allowGroups && strpos($allowGroups, ",$groupId,") !== false) {
  return true;
 }
 if ($allowGroups && $userGroups) {
  $groupIds = explode(',', substr($userGroups, 1, -1));
  foreach ($groupIds as $value) {
   if (strpos($allowGroups, ",$value,") !== false) {
    return true;
   }
  }
 }
 if ($fid && $allowForums && strpos(",$allowForums,", ",$fid,") !== false) {
  return true;
 }
 return false;
}

//在线用户业务

/**
 * 更新在线用户
 *
 * @global string $runfc
 * @global string $db_online
 */
function Update_ol() {
 global $runfc, $db_online;
 if ($runfc == 'Y') {
  if ($db_online) {
   Sql_ol();
  } else {
   Txt_ol();
  }
  $runfc = 'N';
 }
}

/**
 * 在线用户文本存储实现
 */
function Txt_ol() {
 global $ol_offset, $winduid, $db_ipstates, $isModify;
 require_once (R_P . 'require/userglobal.php');
 if ($winduid > 0) {
  list($alt_offset, $isModify) = addonlinefile($ol_offset, $winduid);
 } else {
  list($alt_offset, $isModify) = addguestfile($ol_offset);
 }
 $alt_offset != $ol_offset && Cookie('ol_offset', $alt_offset);
 $ipscookie = GetCookie('ipstate');
 if ($db_ipstates && ((!$ipscookie && $isModify === 1) || ($ipscookie && $ipscookie < $GLOBALS['tdtime']))) {
  require_once (R_P . 'require/ipstates.php');
 }
}

/**
 * 在线用户数据库存储实现
 */
function Sql_ol() {
 global $db, $fid, $tid, $timestamp, $windid, $winduid, $onlineip, $groupid, $wind_in, $db_onlinetime, $db_ipstates, $db_today, $lastvisit, $tdtime;
 $olid = (int) GetCookie('olid');
 $ifhide = $GLOBALS['_G']['allowhide'] && GetCookie('hideid') ? 1 : 0;
 $isModify = 0;
 PwNewDB();
 if ($olid) {
  $sqladd = $winduid ? '(uid=' . pwEscape($winduid) . ' OR olid=' . pwEscape($olid) . ' AND uid=0 AND ip=' . pwEscape($onlineip) . ')' : 'olid=' . pwEscape($olid) . ' AND ip=' . pwEscape($onlineip);
  $pwSQL = pwSqlSingle(array('username' => $windid, 'lastvisit' => $timestamp, 'fid' => $fid, 'tid' => $tid,
   'groupid' => $groupid, 'action' => $wind_in, 'ifhide' => $ifhide, 'uid' => $winduid, 'ip' => $onlineip));
  $db->update("UPDATE pw_online SET $pwSQL WHERE $sqladd");
  if ($winduid && $db->affected_rows() > 1) {
   $db->update('DELETE FROM pw_online WHERE uid=' . pwEscape($winduid) . ' AND olid!=' . pwEscape($olid));
  }
 } elseif (!$_COOKIE) {
  $pwSQL = pwSqlSingle(array('username' => $windid, 'lastvisit' => $timestamp, 'fid' => $fid, 'tid' => $tid,
   'groupid' => $groupid, 'action' => $wind_in, 'ifhide' => $ifhide, 'uid' => $winduid));
  $db->update("UPDATE pw_online SET $pwSQL WHERE ip=" . pwEscape($onlineip));
 }
 if (!$olid && $_COOKIE || $db->affected_rows() == 0) {
  $db->update('DELETE FROM pw_online WHERE uid!=0 AND uid=' . pwEscape($winduid) . ' OR lastvisit<' . pwEscape($timestamp - $db_onlinetime));
  $rt = $db->get_one("SELECT MAX(olid) FROM pw_online", MYSQL_NUM);
  $olid = $rt[0] + 1;
  $pwSQL = pwSqlSingle(array('olid' => $olid, 'username' => $windid, 'lastvisit' => $timestamp,
   'ip' => $onlineip, 'fid' => $fid, 'tid' => $tid, 'groupid' => $groupid, 'action' => $wind_in,
   'ifhide' => $ifhide, 'uid' => $winduid));
  $db->update("REPLACE INTO pw_online SET $pwSQL");
  Cookie('olid', $olid);
  $isModify = 1;
 }
 $ipscookie = GetCookie('ipstate');
 if ($db_ipstates && ((!$ipscookie && $isModify === 1) || ($ipscookie && $ipscookie < $GLOBALS['tdtime']))) {
  require_once (R_P . 'require/ipstates.php');
 }
 if ($db_today && $timestamp - $lastvisit > $db_onlinetime) {
  require_once (R_P . 'require/today.php');
 }
}

//论坛业务

/**
 * 判断
 *
 * @return bool
 */
function GetGcache() {
 global $db_fguestnum, $db_tguestnum, $db_guestindex;
 $page = isset($GLOBALS['page']) ? $GLOBALS['page'] : (int) $_GET['page'];
 if (SCR == 'thread' && $page < $db_fguestnum && !isset($_GET['type']) && !GetGP('search')) {
  return true;
 } elseif (SCR == 'read' && $page < $db_tguestnum && !isset($_GET['uid'])) {
  return true;
 } elseif (SCR == 'index' && $db_guestindex && !isset($_GET['cateid'])) {
  return true;
 }
 return false;
}

/**
 * 获取版块短名
 *
 * @global array $winddb
 * @global array $forum
 * @global string $winduid
 * @global string $db_shortcutforum
 * @return array
 */
function pwGetShortcut() {
 static $sForumsShortcut = array();
 if (empty($sForumsShortcut)) {
  global $winduid, $db_shortcutforum;
  $sForumsShortcut = pwGetMyShortcut();
  if (empty($sForumsShortcut)) {
   if (!$db_shortcutforum && $winduid) {
    require_once (R_P . 'require/updateforum.php');
    $sForumsShortcut = updateshortcut();
   } else {
    $sForumsShortcut = $db_shortcutforum;
   }
  }
 }
 return $sForumsShortcut;
}

function pwGetMyShortcut(){
 static $sMyForumsShortcut = array();
 if (empty($sMyForumsShortcut)) {
  global $winddb, $forum;
  if (trim($winddb['shortcut'], ',')) {
   if (!isset($forum)) {
    require (D_P . 'data/bbscache/forum_cache.php');
   }
   $shortcuts = explode(',', $winddb['shortcut']);
   foreach ($shortcuts as $value) {
    if ($value && isset($forum[$value])) {
     $sMyForumsShortcut[$value] = strip_tags($forum[$value]['name']);
    }
   }
  }
 }
 return $sMyForumsShortcut;
}

//任务调度业务

/**
 * 运行任务调度
 */
function runTask() {
 $taskClass = L::loadclass('task', 'task');
 $taskClass->run();
}

//任务系统业务

/**
 * 运行用户任务系统
 *
 * @global string $db_job_isopen
 * @global int $winduid
 * @global int $groupid
 */
function runJob() {
 global $db_job_isopen, $winduid, $groupid;
 if (!$db_job_isopen || !$winduid) {
  return;
 }
 $taskClass = L::loadclass('job', 'job');
 $taskClass->run($winduid, $groupid);
}

//模式

/**
 * 选择模式
 *
 * @param string $modeName 模式名
 */
function selectMode(&$modeName) {
 global $defaultMode, $db_mode, $db_modes, $db_modepages, $pwServer, $db_modedomain;
 if (defined('M_P'))
  return;
 if (in_array(SCR, array('index', 'mode'))) {
  $db_mode = $defaultMode;
  if (!$modeName && $db_modedomain) {
   $modeName = array_search($pwServer['HTTP_HOST'], $db_modedomain);
  }
  if ($db_modes && isset($db_modes[$modeName]) && is_array($db_modes[$modeName]) && $db_modes[$modeName]['ifopen']) {
   $db_mode = $modeName;
  }
  if (!empty($db_mode) && $db_mode != 'bbs' && file_exists(R_P . "mode/$db_mode/")) {
   define('M_P', R_P . "mode/$db_mode/");
   $db_modepages = $db_modepages[$db_mode];
   $GLOBALS['pwModeImg'] = "mode/$db_mode/images";
  }
 }
}

/**
 * 获取二级域名 //TODO 没有被调用
 *
 * @param string $url
 * @param string $mainUrl
 * @return string
 */
function getSecDomain($url, $mainUrl = null) {
 global $pwServer;
 if ($mainUrl && $url == $mainUrl) {
  return '';
 }
 $dirname = substr($pwServer['HTTP_HOST'], 0, strpos($pwServer['HTTP_HOST'], '.'));
 if (preg_match('/[^\w]' . $dirname . '\./i', $mainUrl)) {
  return '';
 }
 return $dirname;
}

//语言包

/**
 * 获取语言包文件路径
 *
 * @param string $lang 语言文件包名
 * @param string $EXT 扩展名
 */
function GetLang($lang, $EXT = 'php') {
 global $tplpath;
 
 if (file_exists(R_P . "template/$tplpath/lang_$lang.$EXT")) {
  return R_P . "template/$tplpath/lang_$lang.$EXT";
 } elseif (file_exists(R_P . "template/wind/lang_$lang.$EXT")) {
  return R_P . "template/wind/lang_$lang.$EXT";
 } else {
  exit("Can not find lang_$lang.$EXT file");
 }
}

//模板

/**
 * 获取模板文件路径
 *
 * @global string $db_mode
 * @global array $db_modes //TODO 未使用
 * @global string $pwModeImg
 * @global string $db_tplstyle
 * @global string $appdir
 * @global array $tplapps
 * @global string $db_tplpath
 * @param string $template 模板文件名
 * @param string $EXT 扩展名
 * @return string
 */
function PrintEot($template, $EXT = 'htm') {
 !$template && $template = 'N';
 static $bbsTemplate = null;
 isset($bbsTemplate) || $bbsTemplate = new template(new bbsTemplate());
 return $bbsTemplate->printEot($template, $EXT);

 global $db_mode, $db_modes, $pwModeImg, $db_tplstyle, $appdir;
 !$template && $template = 'N';

 
 if (!defined('PWERROR')) { //apps template render
  //zhudong 通过判断模板名称为'm_'开头的调用apps目录下的模板
  if (defined('A_P') && $appdir && substr($template,0,2) == 'm_' && file_exists(A_P . "$appdir/template/$template.$EXT")) {
   return Pcv(A_P . "$appdir/template/$template.$EXT");
  }
  if (defined('F_M')/* || ($db_mode && $db_mode != 'bbs')*/) {
   $temp = modeEot($template, $EXT);
   if ($temp)
    return Pcv($temp);
  }
 }
 //if (defined('A_P') && !in_array($template,array('header','footer'))/* || ($db_mode && $db_mode != 'bbs')*/) {
 // return A_P."$appdir/template/$template.$EXT";
 //}
 if (file_exists(R_P . "template/$tplpath/$template.$EXT")) {
  return Pcv(R_P . "template/$tplpath/$template.$EXT");
 } elseif (file_exists(R_P . "template/wind/$template.$EXT")) {
  return Pcv(R_P . "template/wind/$template.$EXT");
 } else {
  exit("Can not find $template.$EXT file");
 }
}

/**
 * 输出页脚，并处理输出缓存中的内容
 */
function footer() {
 global $db, $db_obstart, $db_footertime, $P_S_T, $mtablewidth, $db_ceoconnect, $wind_version, $imgpath, $stylepath, $footer_ad, $db_union, $timestamp, $db_icp, $db_icpurl, $db_advertdb, $groupid, $db_ystats_ifopen, $db_ystats_unit_id, $db_ystats_style, $pwServer, $db_ifcredit, $credit_pop, $db_foot, $db_mode, $db_modes, $shortcutforum, $_G, $winddb, $db_toolbar, $winduid, $db_menuinit, $db_appifopen, $db_job_ispop, $db_job_isopen, $db_siteappkey, $_Navbar,$db_statscode;

 defined('AJAX') && ajax_footer();

 $wind_spend = '';

 //$db_statscode = html_entity_decode($db_statscode);
 $ft_gzip = ($db_obstart ? 'Gzip enabled' : 'Gzip disabled') . $db_union[3];
 if ($db_footertime == 1) {
  $totaltime = number_format((pwMicrotime() - $P_S_T), 6);
  $qn = $db ? $db->query_num : 0;
  $wind_spend = "Total $totaltime(s) query $qn,";
  
 }
 $ft_time = get_date($timestamp, 'm-d H:i');
 $db_icp && $db_icp = "<a href=\"http://www.miibeian.gov.cn\" target=\"_blank\">$db_icp</a>";

 if ($db_toolbar) {
  if ($_COOKIE['toolbarhide']) {
   $toolbarstyle = 'style="display:none"';
   $openbarstyle = '';
   $closebarstyle = 'style="display:none"';
  } else {
   $toolbarstyle = '';
   $openbarstyle = 'style="display:none"';
   $closebarstyle = '';
   if ($db_appifopen) {
    $appshortcut = trim($winddb['appshortcut'], ',');
    if (!empty($appshortcut) && $db_siteappkey) {
     $appshortcut = explode(',', $appshortcut);
     $bottom_appshortcut = array();
     $appclient = L::loadClass('appclient');
     $bottom_appshortcut = $appclient->userApplist($winduid, $appshortcut, 1);
    }
   }
  }
 }
 $db_menuinit = trim($db_menuinit, ',');

 runJob();

 updateCacheData();
 require PrintEot('footer');
 if ($db_advertdb['Site.PopupNotice'] || $db_advertdb['Site.FloatLeft'] || $db_advertdb['Site.FloatRight'] || $db_advertdb['Site.FloatRand']) {
  require PrintEot('advert');
 }
 pwOutPut();
}

function pwOutPut() {
 global $db_htmifopen, $db_redundancy, $SCR, $groupid;
 Update_ol();
 $output = ob_get_contents();
 if ($db_htmifopen) {
  $output = preg_replace("/\<a(\s*[^\>]+\s*)href\=([\"|\']?)((index|cate|thread|read|faq|rss)\.php\?[^\"\'>\s]+\s?)[\"|\']?/ies", "Htm_cv('\\3','<a\\1href=\"')", $output);
 }
 if ($db_redundancy && $SCR != 'post') {
  $output = str_replace(array("\r", '<!--<!---->-->', '<!---->-->', '<!--<!---->', "<!---->\n", '<!---->', '<!-- -->', "<!--\n-->", "\t\t", '    ', "\n\t", "\n\n"), array('', '', '', '', '', '', '', '', '', '',"\n", "\n"), $output);
 } else {
  $output = str_replace(array('<!--<!---->-->','<!---->-->', '<!--<!---->', "<!---->\r\n", '<!---->', '<!-- -->', "\t\t\t"), '', $output);
 }
 if ($SCR != 'post' && !defined('AJAX')) {
  $ceversion = defined('CE') ? 1 : 0;
  $output .= "<script language=\"JavaScript\" src=\"http://init.phpwind.net/init.php?sitehash={$GLOBALS[db_sitehash]}&v={$GLOBALS[wind_version]}&c=$ceversion\"></script>";
 }
 if ($groupid == 'guest' && !defined('MSG') && GetGcache()) {
  require_once (R_P . 'require/guestfunc.php');
  creatguestcache($output);
 }
 echo ObContents($output);
 unset($output);
 N_flush();
 exit();
}

/**
 * 获取目录路径
 *
 * @param string $path 文件路径
 * @return string
 */
function getdirname($path = null) {
 if (!empty($path)) {
  if (strpos($path, '\\') !== false) {
   return substr($path, 0, strrpos($path, '\\')) . '/';
  } elseif (strpos($path, '/') !== false) {
   return substr($path, 0, strrpos($path, '/')) . '/';
  }
 }
 return './';
}

/**
 * 设置状态
 *
 * @param int $status
 * @param int $b
 * @param string $setv
 */
function setstatus(&$status, $b, $setv = '1') {
 --$b;
 for ($i = strlen($setv) - 1; $i >= 0; $i--) {
  if ($setv[$i]) {
   $status |= 1 << $b;
  } else {
   $status &= ~(1 << $b);
  }
  ++$b;
 }
 //return $status;
}


//安全

/**
 * 获取客户端唯一hash
 *
 * @param string $str 附加信息
 * @param string $app
 * @return string
 */
function GetVerify($str, $app = null) {
 empty($app) && $app = $GLOBALS['db_siteid'];
 return substr(md5($str . $app . $GLOBALS['pwServer']['HTTP_USER_AGENT']), 8, 8);
}

/**
 * POST请求检查
 *
 * @global array $pwServer
 * @param int $checkHash 是否检查请求hash
 * @param int $checkGd 是否检查验证码
 * @param int $checkQuestion 是否检查安全问题
 * @param int $checkReferer 是否检查refer
 */
function PostCheck($checkHash = 1, $checkGd = 0, $checkQuestion = 0, $checkReferer = 1) {
 global $pwServer;
 $checkHash && checkVerify();
 if ($checkReferer && $pwServer['REQUEST_METHOD'] == 'POST') {
  $refererParsed = @parse_url($pwServer['HTTP_REFERER']);
  if ($refererParsed['host']) {
   list($httpHost) = explode(':', $pwServer['HTTP_HOST']);
   if ($refererParsed['host'] != $httpHost) {
    Showmsg('undefined_action');
   }
  }
 }
 $checkGd && GdConfirm($_POST['gdcode']);
 $checkQuestion && Qcheck($_POST['qanswer'], $_POST['qkey']);
}

/**
 * 校验请求的hash字符串
 *
 * @param string $hash 系统hash的key
 */
function checkVerify($hash = 'verifyhash') {
// GetGP('verify') != $GLOBALS[$hash] && Showmsg('illegal_request');
}

/**
 * 校验验证码
 *
 * @param string $code
 */
function GdConfirm($code,$bool = null) {
 Cookie('cknum', '', 0);
 if (!$code || !SafeCheck(explode("\t", StrCode(GetCookie('cknum'), 'DECODE')), strtoupper($code), 'cknum', 1800)) {
  if($bool){
   return false;
  }else{
   Showmsg('check_error');
  }
 }
 return true;
}

/**
 * 校验问题
 *
 * @global string $db_question
 * @global array $db_answer
 * @param string $answer 答案
 * @param string $qkey
 */
function Qcheck($answer, $qkey) {
 global $db_question, $db_answer;
 if ($db_question && (!isset($db_answer[$qkey]) || $answer != $db_answer[$qkey])) {
  Showmsg('qcheck_error');
 }
}

//数据库

/**
 * 初始化数据库连接
 */
function PwNewDB() {
 if (!is_object($GLOBALS['db'])) {
  global $db, $database, $dbhost, $dbuser, $dbpw, $dbname, $PW, $charset, $pconnect;
  require_once Pcv(R_P . "require/db_$database.php");
  $db = new DB($dbhost, $dbuser, $dbpw, $dbname, $PW, $charset, $pconnect);
 }
}

//系统

/**
 * 加载扩展
 *
 * @param string $module 扩展模块名
 * @param string $checkFunction 检测函数
 * @return bool
 */
function Pwloaddl($module, $checkFunction = 'mysqli_get_client_info') {
 return extension_loaded($module) && $checkFunction && function_exists($checkFunction) ? true : false;
}

/**
 * 操作加锁
 *
 * @param string $action 操作名
 * @param int $uid
 * @return bool 是否成功
 */
function procLock($action, $uid = 0) {
 global $db, $timestamp;
 if ($db->query("INSERT INTO pw_proclock (uid,action,time) VALUES ('$uid','$action','$timestamp')", 'U', false)) {
  return true;
 }
 $db->update("DELETE FROM pw_proclock WHERE uid='$uid' AND action='$action' AND time < '$timestamp' - 30");
 return false;
}

/**
 * 操作解锁
 *
 * @param string $action 操作名
 * @param int $uid
 */
function procUnLock($action = '', $uid = 0) {
 $GLOBALS['db']->update("DELETE FROM pw_proclock WHERE uid='$uid' AND action='$action'");
}

/**
 * 获取微妙时间
 *
 * performance 2010-2-10
 * @return float
 */
function pwMicrotime() {
 $t_array = explode(' ', microtime());
 return $t_array[0] + $t_array[1];
}

/**
 * 生成导航条信息
 *
 * @return array
 */
function pwNavBar() {
 global $winduid, $db_mainnav, $db_menu, $groupid, $winddb, $SCR, $db_modes, $db_mode, $defaultMode, $db_menuinit;
 global $alias, $area_default_alias;

 $tmpLogin = $tmpNav = array();
 if ($groupid != 'guest') {
  require_once (R_P . 'require/showimg.php');
  list($tmpLogin['faceurl']) = showfacedesign($winddb['icon'], 1, 's');
  $tmpLogin['lastlodate'] = get_date($winddb['lastvisit'], 'Y-m-d');
 } else {
  global $db_question, $db_logintype, $db_qcheck;
  if ($db_question) {
   list(, $tmpLogin['qcheck']) = explode("\t", $db_qcheck);
   if ($tmpLogin['qcheck'])
    $tmpLogin['qkey'] = array_rand($db_question);
  }
  if ($db_logintype) {
   for ($i = 0; $i < 3; $i++) {
    if ($db_logintype & pow(2, $i))
     $tmpLogin['logintype'][] = $i;
   }
  } else {
   $tmpLogin['logintype'][0] = 0;
  }
 }

 $currentPostion = array();
 $currentPostion['mode'] = $db_mode;
 if (in_array(SCR, array('index', 'cate', 'mode', 'read', 'thread')) || $SCR == 'm_home') {
  $currentPostion['mode'] = empty($db_mode) ? 'bbs' : $db_mode;
 }
 if ($currentPostion['mode'] == 'area' && $alias && $alias != $area_default_alias) $currentPostion['alias'] = $alias;

 $navConfigService = L::loadClass('navconfig', 'site'); /* @var $navConfigService PW_NavConfig */
 $tmpNav[PW_NAV_TYPE_MAIN] = $navConfigService->findValidNavListByTypeAndPostion(PW_NAV_TYPE_MAIN, $db_mode, $currentPostion);
 $tmpNav[PW_NAV_TYPE_HEAD_LEFT] = $navConfigService->findValidNavListByTypeAndPostion(PW_NAV_TYPE_HEAD_LEFT, $db_mode);
 $tmpNav[PW_NAV_TYPE_HEAD_RIGHT] = $navConfigService->findValidNavListByTypeAndPostion(PW_NAV_TYPE_HEAD_RIGHT, $db_mode);
 $tmpNav[PW_NAV_TYPE_FOOT] = $navConfigService->findValidNavListByTypeAndPostion(PW_NAV_TYPE_FOOT, $db_mode);

 return array($tmpNav, $tmpLogin);
}

/**
 * 生成导航html
 *
 * @param array $navData 导航配置数据数组
 */
function buildNavLinkHtml($navData) {
 $title = strip_tags($navData['title']);
 $navData['style']['b'] && $title = "<b>$title</b>";
 $navData['style']['i'] && $title = "<i>$title</i>";
 $navData['style']['u'] && $title = "<u>$title</u>";
 $navData['style']['color'] && $title = "<font color=\"".$navData['style']['color']."\">$title</font>";

 $target = $navData['target'] ? 'target="_blank"' : '';
 return '<a id="nav_key_up_'.$navData['nid'].'" href="'.$navData['link'].'" title="'.$navData['alt'].'" '.$target.'>'.$title.'</a>';
}

/**
 * 根据用户组来判断站点访问权限
 */
function visitRightByGroup() {
 global $_G, $groupid, $manager, $windid, $pwServer;

 if (S::inArray(SCR,array('sendpwd', 'login', 'register', 'job'))) {
  if (SCR !== 'job' || $pwServer['HTTP_USER_AGENT'] == 'Shockwave Flash' && S::inArray($_GET['action'], array('mutiupload', 'mutiuploadphoto', 'uploadicon'))) return;
 }

 if (empty($_G['allowvisit'])) {
  if (empty($groupid) || $groupid == 'guest') {
   ObHeader('login.php');
  } elseif (!S::inArray($windid, $manager)) {
   @extract($GLOBALS, EXTR_SKIP);
   require_once (R_P.'header.php');
   require_once PrintEot('error');
   footer();
  }
 }
}

class bbsTemplate {

 var $dir;

 function bbsTemplate() {
  $this->dir = R_P . 'template/';
 }

 function getpath($template, $EXT = 'htm') {
  if (!defined('PWERROR')) {
   global $appdir;
   if (defined('A_P') && $appdir && substr($template,0,2) == 'm_' && file_exists(A_P . "$appdir/template/$template.$EXT")) {
    return Pcv(A_P . "$appdir/template/$template.$EXT");
   }
   if (defined('F_M')/* || ($db_mode && $db_mode != 'bbs')*/) {
    $temp = modeEot($template, $EXT);
    if ($temp)
     return Pcv($temp);
   }
  }
  $tplpath = L::style('tplpath');
  if (file_exists($this->dir . "$tplpath/$template.$EXT")) {
   return $this->dir . "$tplpath/$template.$EXT";
  }
  if (file_exists($this->dir . "wind/$template.$EXT")) {
   return $this->dir . "wind/$template.$EXT";
  }
  return false;
 }

 function getDefaultDir() {
  return $this->dir . 'wind/';
 }
}



//global.php结束

L::loadClass('forum', 'forum', false);
L::loadClass('post', 'forum', false);
include_once(D_P.'data/bbscache/cache_post.php');
/**
* 版块缓冲文件
*/
//empty($fid) && Showmsg('undefined_action');
empty($fid) && exit('[err]fid is null[/err]'); //zzcity add

/*Begin Add by liaohu for addfloor*/
if('on' != $_POST['go_lastpage'] && 'ajax_addfloor' == $_POST['type']){
 define("AJAX",1); 
}
/*End Add by liaohu for addfloor*/

$pwforum = new PwForum($fid);
$pwpost  = new PwPost($pwforum);
if (!CkInArray($windid, $manager)) {
 $pwpost->forumcheck();
 $pwpost->postcheck();
}

list($uploadcredit,$uploadmoney,,) = explode("\t", $pwforum->forumset['uploadset']);

$foruminfo =& $pwforum->foruminfo;
$forumset =& $pwforum->forumset;

InitGP(array('action','article','pid','page'));
InitGP(array('special','modelid','pcid', 'cyid','actmid'),GP,2);
$replacedb = array();
$secondurl = "thread.php?fid=$fid";
!$action && $action = "new";
$replayorder_default = 'checked';
if ($action == 'new') {

 $theSpecialFlag = false;//是否是特殊帖子（分类、团购、活动）
 if ($modelid > 0) {/*主题分类*/
  L::loadClass('posttopic', 'forum', false);
  $postTopic = new postTopic($pwpost);
//  if (!$_G['allowmodelid']) {
//   Showmsg('post_allowpost');
//  }
  if (strpos(",".$pwforum->foruminfo['modelid'].",",",".$modelid.",") === false) {
   Showmsg('forum_model_undefined');
  }
  if (!$postTopic->topiccatedb[$postTopic->topicmodeldb[$modelid]['cateid']]['ifable']) {
   Showmsg('topic_cate_unable');
  }
  !$postTopic->topicmodeldb[$modelid]['ifable'] && Showmsg('topic_model_unable');
  $special = $pcid = $actmid = 0;
  $theSpecialFlag = true;
 } elseif ($pcid > 0) {/*团购*/
  L::loadClass('postcate', 'forum', false);
  $postCate = new postCate($pwpost);
  if (strpos(",".$pwforum->foruminfo['pcid'].",",",".$pcid.",") === false) {
   Showmsg('post_allowtype');
  }
  if (!$postCate->postcatedb[$pcid]['ifable']) {
   Showmsg('forum_pc_undefined');
  }
//  if (strpos(",".$_G['allowpcid'].",",",".$pcid.",") === false) {
//   Showmsg('post_allowpost');
//  }
    $special = $modelid = $actmid = 0;
  $theSpecialFlag = true;
 } elseif ($actmid > 0) {/*活动分类*/
  L::loadClass('ActivityForBbs', 'activity', false);
  $postActForBbs = new PW_ActivityForBbs($pwpost);
//  if (!$_G['allowactivity']) {
//   Showmsg('post_allowpost');
//  }
  if (strpos(",".$pwforum->foruminfo['actmids'].",",",".$actmid.",") === false) {
   Showmsg('forum_model_undefined');
  }
  if (!$postActForBbs->activitycatedb[$postActForBbs->activitymodeldb[$actmid]['actid']]['ifable']) {
   Showmsg('topic_cate_unable');
  }
  !$postActForBbs->activitymodeldb[$actmid]['ifable'] && Showmsg('topic_model_unable');
  $special = $pcid = $modelid = 0;
  $theSpecialFlag = true;
 } elseif (!($pwforum->foruminfo['allowtype'] & pow(2,$special))) {
  $modelid = $pcid = $actmid = 0;
  if (empty($special) && $pwforum->foruminfo['allowtype'] > 0) {
   $special = (int)log($pwforum->foruminfo['allowtype'],2);
  } elseif ($pwforum->foruminfo['modelid'] || $pwforum->foruminfo['pcid'] || $pwforum->foruminfo['actmids']) {
   L::loadClass('posttopic', 'forum', false);
   $postTopic = new postTopic($pwpost);
   $modeliddb = explode(",",$pwforum->foruminfo['modelid']);
 
   /*判断分类信息是否存在*/
   foreach ($modeliddb as $value) {
    if ($postTopic->topiccatedb[$postTopic->topicmodeldb[$value]['cateid']]['ifable'] && $_G['allowmodelid'] && $postTopic->topicmodeldb[$value]['ifable']) {
     $modelid = $value;
     $theSpecialFlag = true;
     break;
    }
   }

   /*判断团购是否存在*/
   if (!$modelid) {
    L::loadClass('postcate', 'forum', false);
    $postCate = new postCate($pwpost);
    $pciddb = explode(",",$pwforum->foruminfo['pcid']);
   
    foreach ($pciddb as $value) {
     if ($postCate->postcatedb[$value]['ifable'] && strpos(",".$_G['allowpcid'].",",",".$value.",") !== false) {
      $theSpecialFlag = true;
      $pcid = $value;
      break;
     }
    }
   }

   /*判断活动是否存在*/
   if (!$pcid && !$modelid) {
    L::loadClass('ActivityForBbs', 'activity', false);
    $postActForBbs = new PW_ActivityForBbs($data);

    $actmiddb = explode(",",$pwforum->foruminfo['actmids']);
    foreach ($actmiddb as $value) {
     if ($postActForBbs->activitycatedb[$postActForBbs->activitymodeldb[$value]['actid']]['ifable'] && $_G['allowactivity'] && $postActForBbs->activitymodeldb[$value]['ifable']) {
      $actmid = $value;
      $theSpecialFlag = true;
      break;
     }
    }
    if (!$actmid) {
     Showmsg('post_allowtype');
    }
   }
  } else {
   Showmsg('post_allowtype');
  }

 }
}
/**
* 禁止受限制用户发言
*/
//if ($groupid == 6 || getstatus($winddb['userstatus'], PW_USERSTATUS_BANUSER)) {
// $flag  = 0;
// $bandb = $delban = array();
// $query = $db->query("SELECT * FROM pw_banuser WHERE uid=".pwEscape($winduid));
// while ($rt = $db->fetch_array($query)) {
//  if ($rt['type'] == 1 && $timestamp - $rt['startdate'] > $rt['days']*86400) {
//   $delban[] = $rt['id'];
//  } elseif ($rt['fid'] == 0 || $rt['fid'] == $fid) {
//   $bandb[$rt['fid']] = $rt;
//  } else {
//   $flag = 1;
//  }
// }
// $delban && $db->update('DELETE FROM pw_banuser WHERE id IN('.pwImplode($delban).')');
//
// $updateUser = array();
// if ($groupid == 6 && !isset($bandb[0])) {
//  $updateUser['groupid'] = -1;
// }
// if (getstatus($winddb['userstatus'], PW_USERSTATUS_BANUSER) && !isset($bandb[$fid]) && !$flag) {
//  $userService = L::loadClass('UserService', 'user'); /* @var $userService PW_UserService */
//  $userService->setUserStatus($winduid, PW_USERSTATUS_BANUSER, false);
// }
// if (count($updateUser)) {
//  $userService = L::loadClass('UserService', 'user'); /* @var $userService PW_UserService */
//  $userService->update($winduid, $updateUser);
// }
// if ($bandb) {
//  $bandb = current($bandb);
//  if ($bandb['type'] == 1) {
//   $s_date = get_date($bandb['startdate']);
//   $e_date = $bandb['startdate'] + $bandb['days']*86400;
//   $e_date = get_date($e_date);
//   Showmsg('ban_info1');
//  } else {
//   if ($bandb['type'] == 3) {
//    Cookie('force',$winduid);
//    Showmsg('ban_info3');
//   } else {
//    Showmsg('ban_info2');
//   }
//  }
// }
//}
//if (GetCookie('force') && $winduid != GetCookie('force')) {
// $force = GetCookie('force');
// $bandb = $db->get_one("SELECT type FROM pw_banuser WHERE uid=".pwEscape($force)." AND fid='0'");
// if ($bandb['type'] == 3) {
//  Showmsg('ban_info3');
// } else {
//  Cookie('force','',0);
// }
//}

$userlastptime = $groupid != 'guest' ?  $winddb['lastpost'] : GetCookie('userlastptime');
/**
* 灌水预防
*/
//$tdtime  >= $winddb['lastpost'] && $winddb['todaypost'] = 0;
//$montime >= $winddb['lastpost'] && $winddb['monthpost'] = 0;
//if ($_G['postlimit'] && $winddb['todaypost'] >= $_G['postlimit']) {
// Showmsg('post_gp_limit');
//}
//if ($action != "modify" && !$pwpost->isGM && $_G['postpertime'] && $timestamp>=$userlastptime && $timestamp-$userlastptime<=$_G['postpertime'] && !pwRights($pwpost->isBM,'postpers')) {
// Showmsg('post_limit');
//}
list(,,$postq) = explode("\t", $db_qcheck);
$_G['uploadtype'] && $db_uploadfiletype = $_G['uploadtype'];
$db_uploadfiletype = !empty($db_uploadfiletype) ? (is_array($db_uploadfiletype) ? $db_uploadfiletype : unserialize($db_uploadfiletype)) : array();
empty($db_sellset['type']) && $db_sellset['type'] = array('money');
empty($db_enhideset['type']) && $db_enhideset['type'] = array('rvrc');

//if (empty($_POST['step'])) {
//
// require_once(R_P.'require/credit.php');
// $editor = getstatus($winddb['userstatus'], PW_USERSTATUS_EDITOR) ? 'wysiwyg' : 'textmode';
// !is_numeric($db_attachnum) && $db_attachnum = 1;
// $htmlsell = ($pwforum->foruminfo['allowsell'] && $_G['allowsell']) ? '' : 'disabled';
// $htmlhide = ($pwforum->forumset['allowencode'] && $_G['allowencode']) ? '' : 'disabled';
// $htmlpost = $htmlatt = ($pwforum->foruminfo['allowhide'] && $_G['allowhidden']) ? '' : 'disabled';
// $ifanonymous= ($pwpost->isGM || $pwforum->forumset['anonymous'] && $_G['anonymous']) ? '' : 'disabled';
// $groupid   == 'guest' && $userrvrc = 0;
// $atc_title  = $atc_content = $ifmailck = $selltype = $enhidetype = $alltype = '';
// $uploadfiletype = $uploadfilesize = ' ';
// foreach ($db_uploadfiletype as $key => $value) {
//  $uploadfiletype .= $key.' ';
//  $uploadfilesize .= $key.':'.$value.'KB; ';
// }
// foreach ($credit->cType as $key => $value) {
//  $alltype .= "<option value=\"$key\">".$value."</option>";
// }
// foreach ($db_sellset['type'] as $key => $value) {
//  $selltype .= "<option value=\"$value\">".$credit->cType[$value]."</option>";
// }
// if(is_array($db_enhideset['type'])){
//  foreach ($db_enhideset['type'] as $key => $value) {
//    $enhidetype .= "<option value=\"$value\">".$credit->cType[$value]."</option>";
//  }
// }
// require_once(R_P.'require/showimg.php');
// list($postFaceUrl) = showfacedesign($winddb['icon'],1,'m');
// /**
// * 标题表情
// */
// $icondb = array(
//  '1'=>'1.gif', '2'=>'2.gif',
//  '3'=>'3.gif', '4'=>'4.gif',
//  '5'=>'5.gif', '6'=>'6.gif',
//  '7'=>'7.gif', '8'=>'8.gif'
// );
// if ($db_allowupload && $_G['allowupload']) {
//  $attachsService = L::loadClass('attachs', 'forum');
//  $mutiupload = intval($attachsService->countMultiUpload($winduid));
// }
//
//} else {
 PostCheck(1, ($db_gdcheck & 4) && $winddb['postnum'] < $db_postgd, $winddb['postnum'] < $postq);
 !$windid && $windid = '游客';
 /*
 if ($db_xforwardip && $_POST['_hexie'] != GetVerify($onlineip.$winddb['regdate'].$fid.$tid)) {
  Showmsg('undefined_action');
 }
 */
//}

//默认动漫表情处理
if ($db_windmagic && ($action == 'new' || ($action == 'modify' && $pid == 'tpc'))) {
 $mDef = '';
 @include_once(D_P."data/bbscache/myshow_default.php");
}
//if ($action == "new") {
// require_once(R_P.'require/postnew.php');
 
//} elseif ($action == "reply" || $action == "quote") {

// require_once(R_P.'require/postreply.php');
// require/postreply.php开始

/**
 * 用户组权限判断
 */
if (!$pwforum->foruminfo['allowrp'] && !$pwpost->admincheck && $_G['allowrp'] == 0) {
 Showmsg('reply_group_right');
}
if ($article == '0') {
 $pw_tmsgs = GetTtable($tid);
 $S_sql = ',m.uid,m.groupid,m.userstatus,tm.ifsign,tm.content';
 $J_sql = "LEFT JOIN pw_members m ON m.uid=t.authorid LEFT JOIN $pw_tmsgs tm ON tm.tid=t.tid";
} else {
 $S_sql = $J_sql = '';
}
$tpcarray = $db->get_one("SELECT t.tid,t.fid,t.locked,t.ifcheck,t.author,t.authorid,t.postdate,t.lastpost,t.ifmail,t.special,t.subject,t.type,t.ifshield,t.anonymous,t.ptable,t.replies,t.tpcstatus $S_sql FROM pw_threads t $J_sql WHERE t.tid=" . pwEscape($tid));
$pw_posts = GetPtable($tpcarray['ptable']);
$tpcarray['openIndex'] = getstatus($tpcarray['tpcstatus'], 2);
//$t_date = $tpcarray['postdate'];//主题发表时间 bbspostguide 中用到
if ($tpcarray['fid'] != $fid) {
 Showmsg('illegal_tid');
}
$replytitle = $tpcarray['subject'];
/**
 * convert()需要$tpc_author变量
 */
$tpc_author = $tpcarray['author'];

if ($pwforum->forumset['lock']&& !$pwpost->isGM && $timestamp - $tpcarray['postdate'] > $pwforum->forumset['lock'] * 86400 && !pwRights($pwpost->isBM,'replylock')) {
 $forumset['lock'] = $pwforum->forumset['lock'];
 Showmsg('forum_locked');
}
if (!$pwpost->isGM && !$tpcarray['ifcheck'] && !pwRights($pwpost->isBM,'viewcheck')) {
 Showmsg('reply_ifcheck');
}
if (!$pwpost->isGM && $tpcarray['locked']%3<>0 && !pwRights($pwpost->isBM,'replylock')) {
 Showmsg('reply_lockatc');
}

$special = 0;
$icon = (int)$icon;

//L::loadClass('replypost', 'forum', false);
//replypost.class.php开始
/**
 * Reply
 * 
 * @package Thread
 */
class replyPost {
 
 var $db;
 var $post;
 var $forum;
 var $postdata;
 
 var $data;
 var $att;
 
 var $tid;
 var $tpcArr;
 var $replyToUser;

 var $extraBehavior = null;
 
 function replyPost(&$post) {
  global $db;
  $this->db = & $db;
  $this->post = & $post;
  $this->forum = & $post->forum;
  $this->type = 'Reply';
 }
 
 function setTpc($arr) {
  $this->tpcArr = $arr;
  $this->tid = $this->tpcArr['tid'];
  $this->setBehavior();
 }

 function setBehavior() {
  if ($this->extraBehavior !== null) {
   return;
  }
  if (getstatus($this->tpcArr['tpcstatus'], 1)) {
   $cyid = $this->db->get_value("SELECT cyid FROM pw_argument WHERE tid=" . pwEscape($this->tpcArr['tid']));
   require_once(R_P . 'apps/groups/lib/colonypost.class.php');
   $this->extraBehavior = new PwColonyPost($cyid);
  }
 }

 function setToUser($username) {
  $this->replyToUser = $username;
 }
 
 function creditSet() {
  static $creditset = null;
  if (!isset($creditset)) {
   global $db_creditset, $credit;
   require_once (R_P . 'require/credit.php');
   $creditset = $credit->creditset($this->forum->creditset, $db_creditset);
   $creditset = $creditset[$this->type];
  }
  return $creditset;
 }
 
 function check() {
  $this->post->checkUserCredit($this->creditSet());
  /**
  * 版块权限判断
  */
  if (!$this->getReplyForumRight()) {
   Showmsg('reply_forum_right');
  }
  if ($this->extraBehavior) {
   if (($return = $this->extraBehavior->replyCheck()) !== true) {
    return $this->post->showmsg($return);
   }
  }
 }
 
 function setPostData(&$postdata) {
  $this->postdata = & $postdata;
  $this->att = & $postdata->att;
  $this->data = $postdata->getData();
  if (stripslashes($this->data['title']) == 'Re:' . $this->tpcArr['subject']) {
   $this->data['title'] = '';
  }
 }
 
 /**
  * @author papa
  * @param $pid
  * @return unknown_type
  */
 function setPostFloor($pid) {
  $sql = "INSERT INTO pw_postsfloor SET pid=" . pwEscape($pid) . ", tid=" . pwEscape($this->tid);
  $this->db->update($sql);
 }
 
 function execute($postdata) {
  global $db_cvtime, $db_ptable, $onlineip, $db_plist;
  $this->setPostData($postdata);
  $ipTable = L::loadClass('IPTable', 'utility');
  $ipfrom = $ipTable->getIpFrom($onlineip);
//  $timestamp = time();
//  $db_cvtime!=0 && $timestamp += $db_cvtime*60;
  $timestamp=$this->data['postdate'];
  $pwSQL = array(
   'fid' => $this->data['fid'],
   'tid' => $this->tid,
   'aid' => $this->data['aid'],
   'author' => $this->data['author'],
   'authorid' => $this->data['authorid'],
   'icon' => $this->data['icon'],
   'postdate' => $timestamp,
   'subject' => $this->data['title'],
   'userip' => $onlineip,
   'ifsign' => $this->data['ifsign'],
   'ipfrom' => $ipfrom,
   'ifconvert' => $this->data['convert'],
   'ifwordsfb' => $this->data['ifwordsfb'],
   'ifcheck' => $this->data['ifcheck'],
   'content' => $this->data['content'],
   'anonymous' => $this->data['anonymous'],
   'ifhide' => $this->data['hideatt']
  );
  $pw_posts = GetPtable($this->tpcArr['ptable']);
  if ($db_plist && count($db_plist) > 1) {
   $this->db->update("INSERT INTO pw_pidtmp(pid) VALUES(null)");
   $pid = $this->db->insert_id();
  } else {
   $pid = '';
  }
  $pwSQL['pid'] = $pid;
  $pwSQL = pwSqlSingle($pwSQL);
  $this->db->update("INSERT INTO $pw_posts SET $pwSQL");
  !$pid && $pid = $this->db->insert_id();
  $this->tpcArr['openIndex'] && $this->setPostFloor($pid);
  $this->pid = $pid;
  if (is_object($this->att) && ($aids = $this->att->getAids())) {
   $this->db->update("UPDATE pw_attachs SET " . pwSqlSingle(array(
    'tid' => $this->tid,
    'pid' => $this->pid
   )) . ' WHERE aid IN(' . pwImplode($aids) . ')');
  }
  if ($this->data['ifcheck'] == 1) {
   $sqladd1 = '';
   $sqladd = array(
    'lastposter' => $this->data['lastposter']
   );
   $this->tpcArr['locked'] < 3 && $this->tpcArr['lastpost'] < $timestamp && $sqladd['lastpost'] = $timestamp;
   $this->data['ifupload'] && $sqladd['ifupload'] = $this->data['ifupload'];
   $ret = $this->sendMail();
   if ($ret & 2) {
    $sqladd['ifmail'] = 4;
   } elseif ($ret & 1) {
    $sqladd1 = "ifmail=ifmail-1,";
   }
   $this->db->update("UPDATE pw_threads SET {$sqladd1}replies=replies+1,hits=hits+1," . pwSqlSingle($sqladd) . " WHERE tid=" . pwEscape($this->tid));
  }
  $this->post->updateUserInfo($this->type, $this->creditSet(), $this->data['content']);
  $this->afterReply();

  if ($this->extraBehavior) {
   $this->extraBehavior->replyPost($this->pid, $this->tid, $this->data);
  }
 }
 
 function sendMail() {
  global $db_msgreplynotice,$db_replysendmail,$db_replysitemail,$windid,$winduid;
  $ret = 0;
  if ($db_msgreplynotice && $this->replyToUser && $this->replyToUser != $windid) {
   M::sendMessage(
    $winduid,
    array($this->replyToUser),
    array(
     'create_uid' => $winduid,
     'create_username' => $windid,
     'title' => getLangInfo('writemsg','subject_replytouser_title',array(
      'windid' => $windid,
      'title'  => substrs(strip_tags($this->tpcArr['subject']), 30, 'Y')
     )),
     'content' => getLangInfo('writemsg','subject_reply_content',array(
      'tid' => $this->tid,
      'pid' => $this->pid,
      'windid' => $windid,
      'content' => substrs(strip_tags($this->data['content']), 60, 'Y')
     )),
    ),
    'sms_reply',
    'sms_reply'
   );
  }
  if ($this->data['authorid'] == $this->tpcArr['authorid']) {
   return $ret;
  }
  if ($db_replysendmail == 1 && ($this->tpcArr['ifmail'] == 1 || $this->tpcArr['ifmail'] == 3)) {
   $userService = L::loadClass('UserService', 'user'); /* @var $userService PW_UserService */
   $receiver = $this->tpcArr['author'];
   $old_title = $this->tpcArr['subject'];
   $detail = $userService->get($this->tpcArr['authorid']);
   $send_address = $detail['email'];
   if (getstatus($detail['userstatus'], PW_USERSTATUS_RECEIVEMAIL)) {
    require_once (R_P . 'require/sendemail.php');
    sendemail($send_address, 'email_reply_subject', 'email_reply_content', 'email_additional');
   }
   $ret = 1;
  }
  if ($db_replysitemail && ($this->tpcArr['ifmail'] == 2 || $this->tpcArr['ifmail'] == 3)) {
   /*
   $userService = L::loadClass('UserService', 'user');
   $rt = $userService->get($this->tpcArr['authorid'], true, false, true);
   $replyinfo = $rt['replyinfo'] ? $rt['replyinfo'] . $this->tid . ',' : ",$this->tid,";
   $userService->update($this->tpcArr['authorid'], array(), array(), array('replyinfo' => $replyinfo));
   if (!getstatus($rt['userstatus'], PW_USERSTATUS_NEWRP)) {
    $userService->setUserStatus($this->tpcArr['authorid'], PW_USERSTATUS_NEWRP, true);
   }
   */
   M::sendMessage(
    $winduid,
    array($this->tpcArr['author']),
    array(
     'create_uid' => $winduid,
     'create_username' => $windid,
     'title' => getLangInfo('writemsg','subject_reply_title',array(
      'windid' => $windid,
      'title'  => substrs(strip_tags($this->tpcArr['subject']), 30, 'Y')
     )),
     'content' => getLangInfo('writemsg','subject_reply_content',array(
      'tid' => $this->tid,
      'pid' => $this->pid,
      'windid' => $windid,
      'content' => substrs(strip_tags($this->data['content']), 60, 'Y')
     )),
    ),
    'sms_reply',
    'sms_reply'
   );
   $ret += 2;
  }
  return $ret;
 }
 
 function afterReply() {
  global $db_ifpwcache, $timestamp, $db_readperpage;
  if ($this->data['ifcheck'] == 1) {
   if ($this->forum->foruminfo['allowhtm'] && !$this->forum->foruminfo['cms'] && $this->tpcArr['replies'] < $db_readperpage) {
    $StaticPage = L::loadClass('StaticPage');
    $StaticPage->update($this->tid);
   }
   if ($this->tpcArr['ifcheck'] == 1) {
    $lastpost = array(
     'subject' => $this->data['title'] ? substrs($this->data['title'], 26) : 'Re:' . substrs($this->tpcArr['subject'], 26),
     'author' => $this->data['lastposter'],
     'lastpost' => $timestamp,
     'tid' => $this->tid,
     't_date' => $this->tpcArr['postdate']
    );
    $this->forum->lastinfo('reply', '+', $lastpost);
   }
   
   //Start Here pwcache
   if ($db_ifpwcache & 270) {
    L::loadClass('elementupdate', '', false);
    $elementupdate = new ElementUpdate($this->forum->fid);
    $elementupdate->special = $this->tpcArr['special'];
    if ($db_ifpwcache & 14) {
     $elementupdate->replySortUpdate($this->tid, $this->forum->fid, $this->tpcArr['postdate'], $this->tpcArr['replies'] + 1);
    }
    if ($db_ifpwcache & 256) {
     $elementupdate->newReplyUpdate($this->tid, $this->forum->fid, $this->tpcArr['postdate']);
    }
    $elementupdate->updateSQL();
   }
   require_once (R_P . 'require/functions.php');
   updateDatanalyse($this->data['authorid'], 'memberThread', 1);
   updateDatanalyse($this->tid, 'threadPost', 1);
   
   // memcache refresh
   $threadsObj = L::loadclass("threads", 'forum');
   $threadsObj->clearThreadByThreadId($this->tid);
   
   // memcache refresh
   $threadlistObj = L::loadclass("threadlist", 'forum');
   $threadlistObj->updateThreadIdsByForumId($this->forum->fid, $this->tid);
  }
  if ($this->postdata->filter->filter_weight > 1) {
   $this->postdata->filter->insert($this->tid, $this->pid, implode(',', $this->postdata->filter->filter_word), $this->postdata->filter->filter_weight);
  }
 }
 
 function getNewId() {
  return $this->pid;
 }

 /**
  * 获取用户在版块中的发表回复权限
  * @author zhudong
  * @return int $right
  */
  function getReplyForumRight() {
  $right = false;
  if ($this->post->admincheck) {
   $right = true;
  } elseif ($this->forum->allowreply($this->post->user,$this->post->groupid)) {
   $right = true;
  } elseif ($this->extraBehavior) {//当在群组中
   $this->extraBehavior->replyCheck() && $right = true;
  }
  return $right;
  }
 
}


//replypost.class.php结束


$replypost = new replyPost($pwpost);
$replypost->setTpc($tpcarray);
$replypost->check();

//if (empty($_POST['step'])) {
// ##主题分类
// $db_forcetype = 0;
// require_once(R_P.'require/bbscode.php');
//
// $hideemail = 'disabled';
// if ($action == 'quote') {
//  if ($article == '0') {
//   $atcarray = $tpcarray;
//  } else {
//   !is_numeric($pid) && Showmsg('illegal_tid');
//   $atcarray = $db->get_one("SELECT p.author,p.authorid,p.subject,p.ifsign,p.postdate,p.content,p.ifshield,p.anonymous,m.uid,m.groupid,m.userstatus FROM $pw_posts p LEFT JOIN pw_members m ON m.uid=p.authorid WHERE p.pid=".pwEscape($pid));
//  }
//  if ($atcarray['ifshield']) {//单帖屏蔽
//   $atcarray['content'] = shield($atcarray['ifshield']=='1' ? 'shield_article' : 'shield_del_article');
//  } elseif ($pwforum->forumBan($atcarray)) {
//   $atcarray['content'] = shield('ban_article');
//  }
//  $ifsign = $atcarray['ifsign'];
//  $old_author = $atcarray['anonymous'] ? $db_anonymousname : $atcarray['author'];
//  $replytitle = $atcarray['subject'];
//  $wtof_oldfile = get_date($atcarray['postdate']);
//  $old_content = $atcarray['content'];
//  $old_content = preg_replace("/\[hide=(.+?)\](.+?)\[\/hide\]/is",getLangInfo('post','hide_post'),$old_content);
//  $old_content = preg_replace("/\[post\](.+?)\[\/post\]/is",getLangInfo('post','post_post'),$old_content);
//  $old_content = preg_replace("/\[sell=(.+?)\](.+?)\[\/sell\]/is",getLangInfo('post','sell_post'),$old_content);
//  $old_content = preg_replace("/\[quote\](.*)\[\/quote\]/is","",$old_content);
//  $bit_content = explode("\n",$old_content);
//
//  if (count($bit_content) > 5) {
//   $old_content = "$bit_content[0]\n$bit_content[1]\n$bit_content[2]\n$bit_content[3]\n$bit_content[4]\n.......";
//  }
//  if (strpos($old_content,$db_bbsurl) !== false) {
//   $old_content = str_replace('p_w_picpath',$db_picpath,$old_content);
//   $old_content = str_replace('p_w_upload',$db_attachname,$old_content);
//  }
//  $old_content = preg_replace("/\<(.+?)\>/is","",$old_content);
//  $atc_content = "[quote]".($article==0 ? getLangInfo('post','info_post_1') : getLangInfo('post','info_post_2'))."\n{$old_content} [url={$db_bbsurl}/job.php?action=topost&tid=$tid&pid=$pid][img]{$imgpath}/back.gif[/img][/url]\n[/quote]\n";
// }
// list($guidename, $forumtitle) = $pwforum->getTitle();
// $guidename .= " &raquo; <a href=\"read.php?tid=$tid\">$tpcarray[subject]</a>";
// if (!$replytitle) {
//  $atc_title = "Re:$tpcarray[subject]";
//  $forumtitle = "$atc_title|$forumtitle";
// } else {
//  $atc_title = "Re:$replytitle";
//  $forumtitle = "$atc_title|$tpcarray[subject]|$forumtitle";
// }
// $atc_title = substrs(str_replace('&nbsp;',' ',$atc_title), $db_titlemax - 2);
// $db_metakeyword = str_replace(array('|',' - '),',',$forumtitle).'phpwind';
//
// require_once(R_P.'require/header.php');
// $msg_guide = $pwforum->headguide($guidename);
// $post_reply = '';
//
// if ($db_showreplynum > 0) {
//  $wordsfb = L::loadClass('FilterUtil', 'filter');
//  $pwAnonyHide = $pwpost->isGM || pwRights($pwpost->isBM,'anonyhide');
//  $query = $db->query("SELECT p.author,p.authorid,p.subject,p.postdate,p.content,p.anonymous,p.ifconvert,p.ifwordsfb,p.ifshield,m.uid,m.groupid,m.userstatus FROM $pw_posts p LEFT JOIN pw_members m ON p.authorid=m.uid WHERE tid=".pwEscape($tid)."AND ifcheck='1' ORDER BY postdate DESC LIMIT 0,$db_showreplynum");
//
//  while ($rt = $db->fetch_array($query)) {
//   $tpc_author = ($rt['anonymous'] && !$pwAnonyHide && $windid != $rt['author']) ? $db_anonymousname : $rt['author'];
//   if ($rt['ifshield']) {
//    $groupid != '3' && $rt['content'] = shield($rt['ifshield'] == '1' ? 'shield_article' : 'shield_del_article');
//   } elseif ($groupid != 3 && $db_shield && $pwforum->forumBan($rt)) {
//    $rt['content'] = shield('ban_article');
//   } else {
//    if (!$wordsfb->equal($rt['ifwordsfb'])) {
//     $rt['content'] = $wordsfb->convert($rt['content']);
//    }
//    $rt['ifconvert'] == 2 && $rt['content'] = convert($rt['content'],$db_windpost);
//    if (strpos($rt['content'],'[p:') !== false || strpos($rt['content'],'[s:') !== false) {
//     $rt['content'] = showface($rt['content']);
//    }
//   }
//   $post_reply .= "<table align=center width=70% cellspacing=1 cellpadding=2 style='TABLE-LAYOUT: fixed;WORD-WRAP: break-word'><tr><td width=100%>$tpc_author:$rt[subject]<br /><br />$rt[content]</td></tr></table><hr size=1 color=$tablecolor width=80%>";
//  }
// }
// if ($winduid && $tpcarray['special'] == 5) {
//  $debatestand = $db->get_value("SELECT standpoint FROM pw_debatedata WHERE pid='0' AND tid=".pwEscape($tid)."AND authorid=".pwEscape($winduid));
//  $debatestand = (int)$debatestand;
//  ${'debate_'.$debatestand} = 'SELECTED';
// }
// /**
//  * 索引设计时为了减少空间,回复的主题可能为空,所以默认为回复主题!
//  */
// require_once PrintEot('post');footer();
//
//} elseif ($_POST['step'] == 2) {

 InitGP(array('atc_title','atc_content'), 'P', 0);
 InitGP(array('atc_anonymous','atc_hideatt','atc_enhidetype','atc_credittype','flashatt','replytouser'), 'P');
 InitGP(array('atc_iconid','atc_convert','atc_autourl','atc_usesign','atc_html','atc_hide','atc_requireenhide','atc_rvrc','atc_requiresell', 'atc_money'), 'P', 2);

 require_once(R_P . 'require/bbscode.php');
 
 $postdata = new replyPostData($pwpost);
 $postdata->data['postdate']=$timestamp; //zzcity add
 
 $atc_title=''; //zzcity add
 $postdata->setTitle($atc_title);
 $postdata->setContent($atc_content);

 $postdata->setConvert($atc_convert, $atc_autourl);
 $postdata->setAnonymous($atc_anonymous);
 $postdata->setHideatt($atc_hideatt);
 $postdata->setIconid($atc_iconid);
 //$postdata->setIfsign($atc_usesign, $atc_html);
 $postdata->data['ifsign']=2; //允许HTML zzcityadd
 $postdata->setHide($atc_hide);
 $postdata->setEnhide($atc_requireenhide, $atc_rvrc, $atc_enhidetype);
 $postdata->setSell($atc_requiresell, $atc_money, $atc_credittype);
 //$replypost->checkdata();
 $postdata->conentCheck();

 L::loadClass('attupload', 'upload', false);
 if (PwUpload::getUploadNum() || $flashatt) {
  $postdata->att = new AttUpload($winduid, $flashatt);
  $postdata->att->check();
  $postdata->att->transfer();
  PwUpload::upload($postdata->att);
 }

 $replypost->setToUser($replytouser);
 $replypost->execute($postdata);
 $pid = $replypost->getNewId();

 if ($winduid && $tpcarray['special'] == 5) {
  L::loadClass("post_5", 'forum/special', false);
  $postdebate = new postSpecial($pwpost);
  $postdebate->reply($tid, $pid);
 }
 
 echo('[ok]pid='.$pid); 
 
// //job sign
// require_once(R_P.'require/functions.php');
// $threads = L::loadClass('Threads', 'forum');
// $thread = $threads->getThreads($tid,!($page>1));
// initJob($winduid,"doReply",array('tid'=>$tid,'user'=>$thread['author']));
//
// if ($postdata->getIfcheck()) {
//  if ($postdata->filter->filter_weight == 3) {
//   $pinfo = 'enter_words';
//   $banword = implode(',',$postdata->filter->filter_word);
//  } else {
//   $pinfo = 'enter_thread';
//  }
//  $j_p = "read.php?tid=$tid&page=e#a";
//  /*Begin Add by liaohu for addfloor*/
//  if('on' != $_POST['go_lastpage'] && 'ajax_addfloor' == $_POST['type']){
//   require_once Pcv(R_P.'require/addfloor.php');
//   exit;
//  }
//  refreshto($j_p,$pinfo);
//  /*Begin Add by liaohu for addfloor*/
// } else {
//  if ($postdata->filter->filter_weight == 2) {
//   $banword = implode(',',$postdata->filter->filter_word);
//   $pinfo = 'post_word_check';
//  } elseif ($postdata->linkCheckStrategy) {
//   $pinfo = 'post_link_check';
//  }  else {
//   $pinfo = 'post_check';
//  }
//  refreshto("thread.php?fid=$fid",$pinfo);
// }
//}
//  require/postreply.php结束

//} elseif ($action == "modify") {
// require_once(R_P.'require/postmodify.php');
//} else {
// Showmsg('undefined_action');
//}
?>